program Mzc2Com;

const ComSize = $13A3;
      HeaderSize = $5A2;
      LastComByte: byte = $3E;
      MzcSize = $E00;
      ComExt = '.com';
      MzcExt = '.mzc';

{$I comhdr.inc}

type TChars = array[0..MzcSize-1] of byte;

var F: file of byte;
    Chars: TChars;
    FileName: string;
    Conv2Com: boolean;

function DetectCom: boolean;
function CompareArray(A, B: array of byte): boolean;
var I: integer;
begin
  for I:= 0 to HeaderSize-1 do
    if A[I] <> B[I] then
      begin CompareArray:= false; Exit end;
  CompareArray:= true
end;
var Header: array[0..HeaderSize-1] of byte;
    I: integer;
    B: byte;
begin
  DetectCom:= false;
  if FileSize(F) = ComSize then
  begin
    for I:= 0 to HeaderSize-1 do Read(F, Header[I]);
    for I:= 0 to MzcSize-1 do Read(F, Chars[I]);
    Read(F, B);
    if CompareArray(Header, ComHeader) and (B = LastComByte) then
      DetectCom:= true
  end
end;

function DetectMzc: boolean;
var I: integer;
begin
  DetectMzc:= (FileSize(F) = MzcSize);
  for I:= 0 to MzcSize-1 do Read(F, Chars[I])
end;

procedure WriteCom;
var I: integer;
begin
  for I:= 0 to HeaderSize-1 do Write(F, ComHeader[I]);
  for I:= 0 to MzcSize-1 do Write(F, Chars[I]);
  Write(F, LastComByte)
end;

procedure WriteMzc;
var I: integer;
begin
  for I:= 0 to MzcSize-1 do Write(F, Chars[I]);
end;

function LowerCase(S: string): string;
var T: string;
    I: integer;
begin
  T:= '';
  for I:= 1 to Length(S) do
    if (S[I] >= 'A') and (S[I] <= 'Z') then
      T:= T+Chr(Ord(S[I])-32) else T:= T+S[I];
  LowerCase:= T
end;

begin
  Writeln('mzc2com - (c) 1999 by hm - gpl licensed');
  if (ParamCount <> 2) or ((LowerCase(ParamStr(1)) <> 'com') and
     (LowerCase(ParamStr(1)) <> 'mzc')) then
  begin
    Writeln('usage: mzc2com mzc|com <filename>');
    Halt(1)
  end;
  FileName:= LowerCase(ParamStr(2));
  Conv2Com:= LowerCase(ParamStr(1)) = 'com';
  if Conv2Com then Assign(F, FileName+MzcExt)
              else Assign(F, FileName+ComExt);
  {$I-} Reset(F); {$I+}
  if IOResult <> 0 then
  begin
    Write('file '''+FileName);
    if Conv2Com then Write(MzcExt) else Write(ComExt);
    Writeln(''' not found');
    Halt(2)
  end;
  if Conv2Com then
  begin
    if not DetectMzc then
    begin
      Writeln('file '''+FileName+MzcExt+''' is not a valid mzc file');
      Halt(3)
    end;
    Close(F); Assign(F, FileName+ComExt); Rewrite(F);
    WriteCom
  end else begin
    if not DetectCom then
    begin
      Writeln('file '''+FileName+ComExt+''' is not a valid com file');
      Halt(3)
    end;
    Close(F); Assign(F, FileName+MzcExt); Rewrite(F);
    WriteMzc
  end;
  Close(F);
  Writeln('conversion succesful');
  Halt(0)
end.

